import { Module, VuexModule, Mutation, Action } from 'vuex-module-decorators'

import myConsultantService from '~/shared/services/my-consultant.service';
import { AgentInfo } from '~/shared/models/agent-info.model';

@Module
export default class AppointmentStore extends VuexModule {

  loginConsultant?: AgentInfo = JSON.parse(localStorage.getItem('login_consultant')!);

  //////////////////////////////////////////////////////////////////////

  //////////////////////////////////////////////////////////////////////

  @Mutation
  SET_LOGIN_CONSULTANT(agentInfo: AgentInfo): void {
    this.loginConsultant = agentInfo;
    localStorage.setItem('login_consultant', JSON.stringify(agentInfo));
  }

  //////////////////////////////////////////////////////////////////////

  @Action({ commit: 'SET_LOGIN_CONSULTANT' })
  async getLoginConsultantDetail(agentNo: string): Promise<AgentInfo> {
    return await myConsultantService.getConsultantDetail(agentNo).then((res) => res);
  }

  @Action({ commit: 'SET_LOGIN_CONSULTANT' })
  async updateConsultantDetail(agentNo: string): Promise<AgentInfo> {
    return await myConsultantService.getConsultantDetail(agentNo).then((res) => res);
  }

}
